/*

 Cipher+.H - Cipher Data Functions

extern int Cipher(char *xSource, char *xTarget, char *Incode_Key)

*/

extern int Cipher(char *xSource, char *xTarget, char *Incode_Key)
{
	static int EndOfFile;
	static char CharBuffer;

	static float Current_Size;

	if(Working_File)fclose(Working_File);
	if(EncryptTemp_File)fclose(EncryptTemp_File);

	if((Working_File = fopen(xSource,"rb")) == NULL)
	{
		Error("Could Not Open Source For Read. Error: 8.");
		return 0;
	}
	if((EncryptTemp_File = fopen(xTarget,"wb")) == NULL)
	{
		Error("Could Not Open Temp File For Write. Error: 9.");
		return 0;
	}

	if(strlen(Incode_Key) < 10)
		fprintf(EncryptTemp_File,"0");

	fprintf(EncryptTemp_File,"%d",strlen(Incode_Key));
	fprintf(EncryptTemp_File,"~%s~",Incode_Key);

	EndOfFile = 1; /* not EOF */
	while(EndOfFile != EOF)
	{
		Current_Size++;
		StatusValue = (Current_Size / SourceFileSize * 100);
		if(CancelFlag)
		{
			if(Working_File)fclose(Working_File);
			if(EncryptTemp_File)fclose(EncryptTemp_File);
			CleanUp(0,1);
			return 0;
		}
		EndOfFile = fscanf(Working_File, "%c", &CharBuffer);
		if(EndOfFile != EOF) fprintf(EncryptTemp_File, "%c", CharBuffer);
	}

	if(Working_File)fclose(Working_File);
	if(EncryptTemp_File)fclose(EncryptTemp_File);

	return 1;
}

