/*

 Cipher-.H - Decipher Data Function

extern int Decipher(char *xSource, char *xTarget, char *Input_Key)

*/

extern int Decipher(char *xSource, char *xTarget, char *Input_Key)
{
	static char LocalTemp[256];
	static int EndOfFile;
	static char CharBuffer;
	if(EncryptTemp_File)fclose(EncryptTemp_File);
	if(Working_File)fclose(Working_File);

	if((EncryptTemp_File = fopen(xSource,"rb")) == NULL)
	{
		Error("Could Not Open Source File For Read. Error: 6");
		return 0;
	}

	static float Current_Size;

	End_Of_File = 0;

	fseek(EncryptTemp_File,0,SEEK_SET);

	fread(LocalTemp,sizeof(char),2,EncryptTemp_File); // Get KeyLength
	KeyLength = CharInt(LocalTemp);

	fseek(EncryptTemp_File,3,SEEK_SET);

	fread(Password,sizeof(char),KeyLength,EncryptTemp_File); // Get Key

	if(strcmp(Password,Input_Key) != 0)
	{
		Status = "The Password You Entered Is Incorrect!";
		return 0;
	}
	fseek(EncryptTemp_File,1,SEEK_CUR);

	if((Working_File = fopen(xTarget,"wb")) == NULL)
	{
		Error("Could Not Open Target File For Write. Error: 7");
		return 0;
	}

	EndOfFile = 1; /* not EOF */
	while(EndOfFile != EOF)
	{
		Current_Size++;
		StatusValue = (Current_Size / SourceFileSize * 100);
		if(CancelFlag)
		{
			if(Working_File)fclose(Working_File);
			if(EncryptTemp_File)fclose(EncryptTemp_File);
			CancelProcess();
			return 0;
		}
		EndOfFile = fscanf(EncryptTemp_File, "%c", &CharBuffer);
		if(EndOfFile != EOF) fprintf(Working_File, "%c", CharBuffer);
	}

	if(EncryptTemp_File)fclose(EncryptTemp_File);
	if(Working_File)fclose(Working_File);

	return 1;
}
/////////////////////////////////////////////////////////////////////

